setwd("/home/sesa/Scrivania/")
#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

#id,author,bug,somiglianza,numfile

#id : commit ID
#author : commit's author
#bug : true if commit is a fix inducing changes
#somiglianza : similarity of the commit
#numfile : num of file touched by commit

#Subsets
data2 <- data[which(data["somiglianza"] != "NaN"),]

bug <- data2[which(data2["bug"] == "true"),]
no_bug <- data2[which(data2["bug"] == "false"),]

#Boxplots
#Similarity
png(file="boxSomiglianza.png")
boxplot(no_bug$somiglianza, bug$somiglianza, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Conceptual Coupling", main="Commit's Focus")
dev.off()


#NumFile
png(file="boxfile.png")
boxplot(no_bug$numfile, bug$numfile, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Num. Files", main="Number of Modified Files")

dev.off()
