setwd("/home/sesa/Scrivania/")

#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)


#id,bug,ccdb,ccdbm,ccdbmm,kdb,cct,cctm,cctmm,kt

#id : commit ID
#bug : true if commit is a fix inducing changeì
#ccdb : Conceptual Coupling Dynamic Background (text currentCommit - text background)
#ccdbm : Conceptual Coupling Dynamic Background (mean foreach file: text file - text background)
#ccdbmm : Conceptual Coupling Dynamic Background (median foreach file: text file - text background)
#kdb : Knowledge Dynamic Background
#cct : Conceptual Coupling Progressive Loss of Memory Time Treshold (text currentCommit - text background)
#cctm : Conceptual Coupling Progressive Loss of Memory Time Treshold (mean foreach file: text file - text background)
#cctmm : Conceptual Coupling Progressive Loss of Memory Time Treshold (median foreach file: text file - text background)
#kt : Knowledge Progressive Loss of Memory Time Treshold

#This is the mapping for the variables used in the paper:
#ExpLex -> CCDBM
#ExpRecLex -> CCTM
#ExpFreq -> KDB
#ExpRecFreq -> KT 


#Subsets
bug <- data[which(data["bug"] == "true"),]
no_bug <- data[which(data["bug"] == "false"),]


#Boxplots
#Dynamic Background
png(file="boxplot_cc_db.png")
boxplot(no_bug$ccdbm, bug$ccdbm, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Conceptual Coupling", main="Conceptual Coupling Complete Background")
dev.off()

png(file="boxplot_k_db.png")
boxplot(no_bug$kdb, bug$kdb, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Knowledge", main="Knowledge Complete Background")
dev.off()

#Time Treshold
png(file="boxplot_cc_t.png")
boxplot(no_bug$cctm, bug$cctm, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Conceptual Coupling", main="Conceptual Coupling Progressive Loss of Memory")
dev.off()


png(file="boxplot_k_t.png")
boxplot(no_bug$kt, bug$kt, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Knowledge", main="Knowledge Progressive Loss of Memory")

dev.off()
