setwd("/home/sesa/Scrivania/")

#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

#id,author,bug,interferences,lines,interferencesforbug,linesforbug
#id : commit ID
#author : commit's author
#bug : true if commit is fix inducing changes
#interferences : num interferences
#lines : num of lines of interferences
#interferencesforbug :  num interferences only on bug file
#linesforbug : num of lines of interferences only on bug file

#Subsets
bug <- data[which(data["bug"] == "true"),]
no_bug <- data[which(data["bug"] == "false"),]

#Boxplots
#Similarity
png(file="boxplot_num_interf.png")
boxplot(no_bug$interferences, bug$interferences, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Interferences", main="Number of Interferences", ylim=c(0,10))

dev.off()

png(file="boxplot_size_interf.png")
boxplot(no_bug$lines, bug$lines, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Lines of Interferences", main="Size Interferences",ylim=c(0,50))
dev.off()
