library(orddom)

#Load Data

stats = function(root, proj){ 
file = paste(root,proj,".csv", sep="");

data<-read.table(file,sep=",",header=TRUE)

#id,author,bug,somiglianza,numfile
#somiglianza = similarity

#Subsets
bug <- data[which(data["bug"] == "true"),]
no_bug <- data[which(data["bug"] == "false"),]

#Summary info - Size (Num Involved Files)
print("----------- Summary Info Size -----------")
print("Summary Size Num Involved Files  (BUG)")
print(summary(bug$numfile))
print("Std  (BUG)")
sd(bug$numfile, na.rm = FALSE)
print("Summary Size Num Involved Files  (NO_BUG)")
print(summary(no_bug$numfile))
print("Std  (NO_BUG)")
sd(no_bug$numfile, na.rm = FALSE)

#Summary info - Size (Num Involved Files)
print("----------- Summary Info Bug -----------")
print("Summary (BUG)")
print(nrow(bug))
print("Summary (NO_BUG)")
print(nrow(no_bug))


#Statistical test
print("----------- Statistical Test - WilcoxTest -----------")
print(wilcox.test(no_bug$numfile, bug$numfile,alternative="less",paired=FALSE))

#small for d < 0.33 (positive as well as negative values), 
#medium for 0.33 ≤ d < 0.474 and large for d ≥ 0.474.
#Summary info
print("----------- Cliff's Delta -----------")
t1=as.matrix(no_bug$numfile)
colnames(t1)<-c("t1")
t2=as.matrix(bug$numfile)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
print(cliffdelta)


}


root = "/home/scratch/mtufano/tmp/numFiles/";

print("**************** ANT ****************")
proj = "ant";
stats(root, proj);

print("**************** JMETER ****************")
proj = "jmeter";
stats(root, proj);

print("**************** LOG4J ****************")
proj = "log4j";
stats(root, proj);

print("**************** TOMCAT ****************")
proj = "tomcat";
stats(root, proj);

print("**************** XERCESJ ****************")
proj = "xercesj";
stats(root, proj);

