setwd("/home/sesa/Scrivania/")
pdf("/home/sesa/Scrivania/boxplots.pdf")
#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

#id,author,numfilebug,somiglianzafilebug,numfilebugnonbug,somiglianzafilenonbug

#id : commit ID
#author : commit's author
#numfilebug : num of file bug in commit
#somiglianzafilebug : Similarity between buggy and non-buggy files
#numfilebugnonbug : num of file non-buggy in the commit
#somiglianzafilenonbug :  Similarity among non-buggy files

#Subsets
data2 <- data[which(data["somiglianzafilebug"] != "NaN"),]
data_NotNan <- data2[which(data2["somiglianzafilenonbug"] != "NaN"),]
data_Not1 <- data_NotNan[which(data_NotNan["numfilebugnonbug"] > 1),]

#Summary info
print("----------- Summary Info -----------")
print("Summary Somiglianza Locale File Bug-NonBug")
summary(data_NotNan$somiglianzafilebug)
print("Summary Somiglianza Locale tra File Non-Bug")
summary(data_NotNan$somiglianzafilenonbug)
print("Summary Somiglianza Locale File Bug-NonBug [file > 1]")
summary(data_Not1$somiglianzafilebug)
print("Summary Somiglianza Locale tra File Non-Bug [file > 1]")
summary(data_Not1$somiglianzafilenonbug)

#Boxplots
#Similarity
boxplot(data_NotNan$somiglianzafilenonbug, data_NotNan$somiglianzafilebug, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Conceptual Coupling", main="Somiglianza Locale File")
boxplot(data_Not1$somiglianzafilenonbug, data_Not1$somiglianzafilebug, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Conceptual Coupling", main="Somiglianza Locale File [file > 1]")


#Statistical test
print("----------- Statistical Test - WilcoxTest -----------")
wilcox.test(data_NotNan$somiglianzafilebug, data_NotNan$somiglianzafilenonbug,alternative="less",paired=FALSE)
wilcox.test(data_Not1$somiglianzafilebug, data_Not1$somiglianzafilenonbug,alternative="less",paired=FALSE)

library(orddom)

#small for d < 0.33 (positive as well as negative values), 
#medium for 0.33 ≤ d < 0.474 and large for d ≥ 0.474.
#Summary info
print("----------- Cliff's Delta -----------")
print("Somiglianza Locale")
t1=as.matrix(data_NotNan$somiglianzafilenonbug)
colnames(t1)<-c("t1")
t2=as.matrix(data_NotNan$somiglianzafilebug)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("Somiglianza Locale [file > 1]")
t1=as.matrix(data_Not1$somiglianzafilebug)
colnames(t1)<-c("t1")
t2=as.matrix(data_Not1$somiglianzafilenonbug)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta


dev.off()
