setwd("/home/sesa/Scrivania/")

#Load Data
data_size<-read.table("stats_size.csv",sep=",",header=TRUE)
data_experience<-read.table("stats_experience.csv",sep=",",header=TRUE)
data_coherence<-read.table("stats_coherence.csv",sep=",",header=TRUE)
data_interferences<-read.table("stats_interferences.csv",sep=",",header=TRUE)
data_structuralFocus<-read.table("stats_structuralFocus.csv",sep=",",header=TRUE)
data_addModRem<-read.table("stats_addModRem.csv",sep=",",header=TRUE)

#DATA_SIZE
#id,bug,lines,hunks

#DATA_EXPERIENCE
#id,bug,ccdb,ccdbm,ccdbmm,kdb,cct,cctm,cctmm,kt

#DATA_COHERENCE
#id,author,bug,somiglianza,numfile

#DATA_INTERFERENCES
#id,author,bug,interferences,lines,interferencesforbug,linesforbug

#DATA_STRUCTURALFOCUS
#id,bug,structuralFocus

#id : commit ID
#bug : true if commit is a fix inducing change
#ccdb : Conceptual Coupling Dynamic Background (text currentCommit - text background)
#ccdbm : Conceptual Coupling Dynamic Background (mean foreach file: text file - text background)
#ccdbmm : Conceptual Coupling Dynamic Background (median foreach file: text file - text background)
#kdb : Knowledge Dynamic Background
#cct : Conceptual Coupling Progressive Loss of Memory Time Treshold (text currentCommit - text background)
#cctm : Conceptual Coupling Progressive Loss of Memory Time Treshold (mean foreach file: text file - text background)
#cctmm : Conceptual Coupling Progressive Loss of Memory Time Treshold (median foreach file: text file - text background)
#kt : Knowledge Progressive Loss of Memory Time Treshold

#This is the mapping for the variables used in the paper:
#ExpLex -> CCDBM
#ExpRecLex -> CCTM
#ExpFreq -> KDB
#ExpRecFreq -> KT 

data_experience <- data_experience[which(data_experience["ccdb"] != "NaN"),]
data_experience <- data_experience[which(data_experience["ccdbm"] != "NaN"),]
data_experience <- data_experience[which(data_experience["ccdbmm"] != "NaN"),]
data_experience <- data_experience[which(data_experience["kdb"] != "NaN"),]
data_experience <- data_experience[which(data_experience["cct"] != "NaN"),]
data_experience <- data_experience[which(data_experience["cctm"] != "NaN"),]
data_experience <- data_experience[which(data_experience["cctmm"] != "NaN"),]
data_experience <- data_experience[which(data_experience["kt"] != "NaN"),]

table <- merge(x=data_size, y=data_experience, by="id", all.y=TRUE)
table <- merge(x=table, y=data_coherence, by="id", all.x=TRUE)
data_interferences$author <- NULL
data_interferences$bug <- NULL
table <- merge(x=table, y=data_interferences, by="id", all.x=TRUE)
data_structuralFocus$bug <- NULL
table <- merge(x=table, y=data_structuralFocus, by="id", all.x=TRUE)
data_structuralFocus$size_lines <- NULL
table <- merge(x=table, y=data_addModRem, by="id", all.x=TRUE)


#id, author, bug, added_lines, modified_lines, removed_lines, size_lines, size_hunks, num_files, exp_ccdbm, exp_cctm, exp_kdb, exp_kt, coherence_lex, coherence_struct, num_interferences, num_lines_interferences

finalTable <- table[1]
finalTable["author"] <- table$author
finalTable["bug"] <- table$bug
finalTable["added_lines"] <- table$added_lines
finalTable["modified_lines"] <- table$modified_lines
finalTable["removed_lines"] <- table$removed_lines
finalTable["size_lines"] <- table$size_lines
finalTable["size_hunks"] <- table$hunks
finalTable["num_files"] <- table$numfile
finalTable["exp_ccdbm"] <- table$ccdbm
finalTable["exp_cctm"] <- table$cctm
finalTable["exp_kdb"] <- table$kdb
finalTable["exp_kt"] <- table$kt
finalTable["coherence_lex"] <- table$somiglianza
finalTable["coherence_struct"] <- table$structuralFocus
finalTable["num_interferences"] <- table$interferences
finalTable["num_lines_interferences"] <- table$lines.y


write.csv(file="merged.csv", finalTable, row.names=FALSE)
